﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace WindowsFormsApplication5
{
    public partial class Form1 : Form
    {
        Graphics g, gx,gy;
        Brush brush;
        Brush white;
        Pen greenPen;
        
        int msec = 0;
        int x, y, t, xPos, yPos, tPos, aPos, bPos, cPos;
        int lastX, lastY = 0;
        bool condCLearX, condCLearY = false;
        string answer;
        string measure;
       
        private void timer1_Tick(object sender, EventArgs e)
        {
            msec += 100;
            label1.Text = (msec / 1000).ToString();
            answer = port.ReadLine();
         
              int xPos = answer.IndexOf('x');
               int yPos = answer.IndexOf('y');
               int tPos = answer.IndexOf('t');
             int aPos = answer.IndexOf('a');
              int bPos = answer.IndexOf('b');
              int cPos = answer.IndexOf('c');

            measure = answer.Substring(xPos + 1, aPos - xPos - 1);
            x = Convert.ToInt32(measure) - 180;
            if (lastX == x)
                condCLearX = true;
            else
                condCLearX = false;
            lastX = x;
            label3.Text = "x: " + Convert.ToString(x); 

            measure = answer.Substring(yPos + 1, bPos - yPos - 1);
            y = Convert.ToInt32(measure) - 180;
            if (lastY == y)
                condCLearY = true;
            else
                condCLearY = false;
         
            lastY = y;

            label4.Text ="y: " + Convert.ToString(y);
            measure = answer.Substring(tPos + 1, cPos - tPos - 1);
            label5.Text = measure;
            
            gx.FillRectangle(white, 0, 0, xAxis.Width, xAxis.Height);
            if (x > 0)
            gx.FillRectangle(brush, xAxis.Width/2, 0, x, xAxis.Height);
            else
            gx.FillRectangle(brush, xAxis.Width / 2+x, 0, Math.Abs(x), xAxis.Height);

            gy.FillRectangle(white, 0, 0, yAxis.Width, yAxis.Height);
            if (y > 0)
                gy.FillRectangle(brush, 0 , yAxis.Height/2 ,yAxis.Width, y );
            else
                gy.FillRectangle(brush,0, yAxis.Height/2 +y ,yAxis.Width,Math.Abs(y));
            if (condCLearX == true || condCLearY == true)
                g.FillRectangle(white, 0, 0, pictureBox1.Width, pictureBox1.Height);
            g.DrawLine(greenPen, 0, pictureBox1.Height / 2, pictureBox1.Width, pictureBox1.Height / 2);
            g.DrawLine(greenPen, pictureBox1.Width / 2, 0, pictureBox1.Width / 2, pictureBox1.Height);
            g.FillEllipse(brush, pictureBox1.Width/2 + x, pictureBox1.Height/2 + y, 10, 10);    
        }

        private void connect_Click(object sender, EventArgs e)
        {
          
            g.DrawLine(greenPen, 0, pictureBox1.Height / 2, pictureBox1.Width, pictureBox1.Height / 2);
            g.DrawLine(greenPen, pictureBox1.Width/2, 0, pictureBox1.Width/2, pictureBox1.Height);

            port.Open();
            timer1.Start();

            msec = 0;
        }
        private void disconnect_Click(object sender, EventArgs e)
        {
            port.Close();
            timer1.Stop();
            label1.Text = "STOPPED";
            label3.Text = " Y: offline";
            label4.Text = "X : offline";
            label5.Text = "offline";
            gx.FillRectangle(white, 0, 0, xAxis.Width, xAxis.Height);
            gy.FillRectangle(white, 0, 0, yAxis.Width, yAxis.Height);
            g.FillRectangle(white, 0, 0, pictureBox1.Width, pictureBox1.Height);
        }

        public Form1()
        {
            InitializeComponent();
            g = pictureBox1.CreateGraphics();
            gx = xAxis.CreateGraphics();
            gy = yAxis.CreateGraphics();
            greenPen = new Pen(Color.Green);
            brush = new SolidBrush(Color.Green);
            white = new SolidBrush(Color.White);



        }



        private void Form1_Load(object sender, EventArgs e)
        {
            label1.Text = "STOPPED";
            label3.Text = " Y: offline";
            label4.Text = "X : offline";
            label5.Text = "offline";           
        }
    }
}
